package com.jln.system.web.action.mqtt;

import com.alibaba.fastjson.JSONObject;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mqtt.pojo.dto.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;
import java.lang.reflect.Field;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;

@Slf4j
@Component
public class Base64decrypt {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Value("${jugeTime}")
    private Long jugeTime;

    @Value("${sleepTime}")
    private Long sleepTime;

    /**
     * 坡口机器人01 已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     */
    public Map<String, Object> pkjqr01SendString(Map<String, String> comparison, String deviceId, PkjqrReportDataDto pkjqrReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo(deviceId + "01");
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = pkjqrReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {
                    if ("Status".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getNcVer());
                    } else {
                        f.set(pkjqrReportDataDto, "");
                    }
                } else {
                    long time = Long.valueOf(map.get("time").toString());
                    if (map.get(comparison.get(f.getName())) != null) {
                        if ((millis - time) > jugeTime) {
                            if ("Status".equals(f.getName())) {
                                f.set(pkjqrReportDataDto, "4");
                            }
                        } else {
                            String txt = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                            if ("d5".equals(comparison.get(f.getName()))) {
                                if (txt.toUpperCase().indexOf("AUTO") != -1) {
                                    txt = "1";
                                } else if (txt.toUpperCase().indexOf("MANUAL") != -1) {
                                    txt = "6";
                                } else if (txt.toUpperCase().indexOf("MDI") != -1) {
                                    txt = "3";
                                } else if (txt.toUpperCase().indexOf("DNC") != -1) {
                                    txt = "4";
                                } else if (txt.toUpperCase().indexOf("HOMEAXES") != -1) {
                                    txt = "5";
                                } else {
                                    txt = "2";
                                }
                            } else if ("d4".equals(comparison.get(f.getName()))) {
                                txt = "['" + txt + "']";
                            } else if ("Status".equals(f.getName())) {
                                String d = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                                if (d.equals("1") || d.equals("2") || d.equals("4")) {
                                    txt = d;
                                } else if (d.equals("3")) {
                                    txt = "2";
                                } else if (d.equals("")) {
                                    txt = "4";
                                } else {
                                    txt = "2";
                                }

                            }
                            f.set(pkjqrReportDataDto, txt);
                        }
                    } else {
                        if ("Status".equals(f.getName())) {
                            f.set(pkjqrReportDataDto, "4");
                        }
                    }
                }
                Sites2.put(f.getName(), f.get(pkjqrReportDataDto) != null ? f.get(pkjqrReportDataDto).toString() : "");
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }

    /**
     * 坡口机器人02 已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     */
    public Map<String, Object> pkjqr02SendString(Map<String, String> comparison, String deviceId, PkjqrReportDataDto pkjqrReportDataDto, Map<String, Object> reportDto) {

        Map map1 = findMongo(deviceId + "01");
        Map map = findMongo(deviceId + "02");
        if (!ObjectUtils.isEmpty(map1)) {
            map.putAll(map1);
        }
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = pkjqrReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {
                    if ("Status".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(pkjqrReportDataDto, pkjqrReportDataDto.getNcVer());
                    } else {
                        f.set(pkjqrReportDataDto, "");
                    }
                } else {
                    long time = Long.valueOf(map.get("time").toString());
                    if (map.get(comparison.get(f.getName())) != null) {
                        if ((millis - time) > jugeTime) {
                            f.set(pkjqrReportDataDto, "");
                            if ("Status".equals(f.getName())) {
                                f.set(pkjqrReportDataDto, "4");
                            }
                        } else {
                            String txt = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                            if ("d47".equals(comparison.get(f.getName()))) {
                                txt = "['" + txt + "']";
                            } else if ("d48".equals(comparison.get(f.getName()))) {
                                if (txt.toUpperCase().indexOf("AUTO") != -1) {
                                    txt = "1";
                                } else if (txt.toUpperCase().indexOf("MANUAL") != -1) {
                                    txt = "6";
                                } else if (txt.toUpperCase().indexOf("MDI") != -1) {
                                    txt = "3";
                                } else if (txt.toUpperCase().indexOf("DNC") != -1) {
                                    txt = "4";
                                } else if (txt.toUpperCase().indexOf("HOMEAXES") != -1) {
                                    txt = "5";
                                } else {
                                    txt = "2";
                                }
                            } else if ("Status".equals(f.getName())) {
                                String d = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                                if (d.equals("1") || d.equals("2") || d.equals("4")) {
                                    txt = d;
                                } else if (d.equals("3")) {
                                    txt = "2";
                                } else if (d.equals("")) {
                                    txt = "4";
                                } else {
                                    txt = "2";
                                }
                            }
                            f.set(pkjqrReportDataDto, txt);
                        }
                    } else {
                        if ("Status".equals(f.getName())) {
                            f.set(pkjqrReportDataDto, "4");
                        }
                    }
                }
                Sites2.put(f.getName(), f.get(pkjqrReportDataDto) != null ? f.get(pkjqrReportDataDto).toString() : "");
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }

    /**
     * 400折弯机  已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     */
    public Map<String, Object> zwjSendString(Map<String, String> comparison, String deviceId, ZwjReportDataDto zwjReportDataDto, Map<String, Object> reportDto) {

        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = zwjReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {
                    if ("Status".equals(f.getName())) {
                        f.set(zwjReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getNcVer());
                    } else if ("MaxPres".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getMaxPres());
                    } else if ("TableSize".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getTableSize());
                    } else {
                        f.set(zwjReportDataDto, "");
                    }
                } else {
                    long time = Long.valueOf(map.get("time").toString());
                    if (map.get(comparison.get(f.getName())) != null) {
                        if ((millis - time) > jugeTime) {
                            if ("Status".equals(f.getName())) {
                                f.set(zwjReportDataDto, "4");
                            }
                        } else {
                            String txt = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                            if ("Status".equals(f.getName())) {
//                                String status = map.get(comparison.get(f.getName())).toString();
                                if (txt.equals("1") || txt.equals("2") || txt.equals("4")) {
                                    f.set(zwjReportDataDto, txt);
                                } else if (txt.equals("3")) {  // 客户要求故障显示成待机
                                    f.set(zwjReportDataDto, "2");
                                } else if (txt.equals("")) { // 客户要求上报空显示成关机
                                    f.set(zwjReportDataDto, "4");
                                } else {
                                    f.set(zwjReportDataDto, "2");
                                }
                            }
                            // TODO 报警状态转化 显示0/1
                            if ("d2".equals(comparison.get(f.getName()))) {
                                if ("True".equals(txt)) {
                                    f.set(zwjReportDataDto, "1");
                                } else if ("False".equals(txt)) {
                                    f.set(zwjReportDataDto, "0");
                                }
                            }
                        }
                    } else {
                        //TODO 上报数据异常  ->暂时处理成3异常
                        if ("Status".equals(f.getName())) {
                            f.set(zwjReportDataDto, "4");
                        }
                    }
                }
                Sites2.put(f.getName(), f.get(zwjReportDataDto) == null ? "" : f.get(zwjReportDataDto).toString());
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }


    /**
     * 800折弯机   已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     *
     * @param comparison
     * @param tableName
     * @param zwjReportDataDto
     * @param reportDto
     * @return
     */
    public Map<String, Object> zwj800SendString(Map<String, String> comparison, String
            tableName, Zwj800ReportDataDto zwjReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo(tableName);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = zwjReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {
                    if ("Status".equals(f.getName())) {
                        f.set(zwjReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getNcVer());
                    } else if ("DeviceBrand".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getDeviceBrand());
                    } else if ("MaxPres".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getMaxPres());
                    } else if ("TableSize".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getTableSize());
                    } else if ("LimitUpl".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getLimitUpl());
                    } else if ("LimotDownl".equals(f.getName())) {
                        f.set(zwjReportDataDto, zwjReportDataDto.getLimotDownl());
                    } else {
                        f.set(zwjReportDataDto, "");
                    }
                } else {
                    long time = Long.valueOf(map.get("time").toString());
                    if ((millis - time) > jugeTime) {
                        if ("Status".equals(f.getName())) {
                            f.set(zwjReportDataDto, "4");
                        }
                    } else {
                        String status = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString().trim();
                        if ("d1".equals(comparison.get(f.getName()))) {
                            if (status.equals("EXECUTING") || status.equals("SETUP")) {   //设备上报状态EXECUTING和SETUP显示运行
                                f.set(zwjReportDataDto, "1");
                            } else if (status.equals("")) {//设备上报状态为空 显示关机
                                f.set(zwjReportDataDto, "4");
                            } else {   //设备上报其他的状态值 显示待机
                                f.set(zwjReportDataDto, "2");
                            }
                        } else if ("Alarm".equals(f.getName())) {
                            //设备上报不了这个字段，暂时默认给0
                            f.set(zwjReportDataDto, "0");
                        } else if ("CurPgm".equals(f.getName())) {
                            String curPgm = map.get("d2") == null || map.get("d2").equals("") ? "" : map.get("d2").toString();
                            f.set(zwjReportDataDto, curPgm);
                        }
//                        else {
//                            f.set(zwjReportDataDto, f.get(zwjReportDataDto));
//                        }

                    }
                }
                Sites2.put(f.getName(), f.get(zwjReportDataDto) != null ? f.get(zwjReportDataDto).toString() : "");
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }

//    /**
//     * 激光切割机 已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
//     */
//    public Map<String, Object> jgSendString(Map<String, String> comparison, String deviceId, JgReportDataDto
//            jgReportDataDto, Map<String, Object> reportDto) {
//        Map map = findMongo(deviceId);
//        long millis = Calendar.getInstance().getTimeInMillis();
//        //处理实体类在每个字段加上时间
//        List<Map<String, String>> list = new ArrayList<>();
//        Field[] fields = jgReportDataDto.getClass().getDeclaredFields();
//        for (int i = 0; i < fields.length; i++) {
//            Map<String, String> Sites2 = new HashMap<>();
//            Field f = fields[i];
//            f.setAccessible(true);
//            try {
//                if ("DeviceID".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getDeviceID());
//                } else if ("CompanyNo".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getCompanyNo());
//                } else if ("factoryNo".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getFactoryNo());
//                } else if ("AssetNo".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getAssetNo());
//                } else if ("DeviceName".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getDeviceName());
//                } else if ("DeviceBrand".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getDeviceBrand());
//                } else if ("DeviceType".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getDeviceType());
//                } else if ("CncType".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getCncType());
//                } else if ("NcVer".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getNcVer());
//                } else if ("SerNum".equals(f.getName())) {
//                    f.set(jgReportDataDto, jgReportDataDto.getSerNum());
//                }
//                if (ObjectUtils.isEmpty(map)) {
//                    if ("Status".equals(f.getName())) {
//                        f.set(jgReportDataDto, "4");
//                    } else {
//                        f.set(jgReportDataDto, "0");
//                    }
//                } else {
//                    Long time = Long.valueOf(map.get("time").toString());
//
//                    if (map.get(comparison.get(f.getName())) != null || f.getName().equals("GasPressure")) {
//                        if ((millis - time) > jugeTime) {
//                            if ("Status".equals(f.getName())) {
//                                f.set(jgReportDataDto, "4");
//                            } else {
//                                f.set(jgReportDataDto, "0");
//                            }
//                        } else if ("Status".equals(f.getName())) {
//                            String d1 = map.get(comparison.get(f.getName())).toString();
//                            if (d1.equals("1") || d1.equals("2") || d1.equals("4")) {
//                                f.set(jgReportDataDto, d1);
//                            } else if (d1.equals("3")) {
//                                f.set(jgReportDataDto, "2");
//                            } else if (d1.equals("")) {
//                                f.set(jgReportDataDto, "4");
//                            } else {
//                                f.set(jgReportDataDto, "2");
//                            }
//                        } else if ("CycSec".equals(f.getName())) {
//                            String cycSec = map.get(comparison.get(f.getName())) == null || map.get(comparison.get(f.getName())).equals("") ? "0" : map.get(comparison.get(f.getName())).toString();
//                            f.set(jgReportDataDto, cycSec);
//                        } else if ("PowerVoltage".equals(f.getName())) {
//                            String d29 = map.get("d29") == null ? "" : map.get("d29").toString();
//                            if (d29.equals("1") || d29.equals("2") || d29.equals("3")) {
//                                f.set(jgReportDataDto, "385");
//                            } else {
//                                f.set(jgReportDataDto, "0");
//                            }
//                        }
//
//                        else if ("LaserPower".equals(f.getName())) {
//                            String d29 = map.get("d29") == null ? "" : map.get("d29").toString();
//                            if (d29.equals("1")) {
//                                f.set(jgReportDataDto, "10000");
//                            } else {
//                                f.set(jgReportDataDto, "0");
//                            }
//                        }
//                        else if ("GasPressure".equals(f.getName())) {
//                            String d43 = map.get("d43") == null ? "0" : map.get("d43").toString();
//                            f.set(jgReportDataDto, d43);
//                        }
//                        else {
//                            f.set(jgReportDataDto, map.get(comparison.get(f.getName())));
//                        }
//                    }
//                }
//                Sites2.put(f.getName(), f.get(jgReportDataDto) == null ? "" : f.get(jgReportDataDto).toString());
//                Sites2.put("ts", String.valueOf(millis));
//                list.add(Sites2);
//            } catch (Exception e) {
//                Map<String, String> site = new HashMap<>();
//                site.put("Status", "2");
//                site.put("ts", String.valueOf(millis));
//                list.add(site);
//                reportDto.put("reported", list);
//                reportDto.put("edgeTime", millis);
//                return reportDto;
//            }
//        }
//        reportDto.put("reported", list);
//        reportDto.put("edgeTime", millis);
//        return reportDto;
//    }

    /**
     * 20211102激光切割机 已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     */
    public Map<String, Object> jgSendString(Map<String, String> comparison, String deviceId, JgReportDataDto
            jgReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> allDto = new ArrayList<>();
        Field[] fields = jgReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> sites = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if ("DeviceID".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceID());
                } else if ("CompanyNo".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getCompanyNo());
                } else if ("factoryNo".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getFactoryNo());
                } else if ("AssetNo".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getAssetNo());
                } else if ("DeviceName".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceName());
                } else if ("DeviceBrand".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceBrand());
                } else if ("DeviceType".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceType());
                } else if ("CncType".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getCncType());
                } else if ("NcVer".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getNcVer());
                } else if ("SerNum".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getSerNum());
                } else {
                    if (ObjectUtils.isEmpty(map)) {
                        if ("Status".equals(f.getName())) {
                            f.set(jgReportDataDto, 4);
                        } else {
                            f.set(jgReportDataDto, 0);
                        }
                    } else {
                        String value = map.get(comparison.get(f.getName())) == null ? "0" : map.get(comparison.get(f.getName())).toString();
                        if ("Status".equals(f.getName())) {
                            if (value.equals("1") || value.equals("2") || value.equals("4")) {
                                f.set(jgReportDataDto, value);
                            } else if (value.equals("3")) {
                                f.set(jgReportDataDto, "2");
                            } else if (value.equals("")) {
                                f.set(jgReportDataDto, "4");
                            } else {
                                f.set(jgReportDataDto, "2");
                            }
                        } else if ("GasPressure".equals(f.getName())) {
                            String d43 = map.get("d43") == null ? "0" : map.get("d43").toString();
                            f.set(jgReportDataDto, d43);
                        } else if ("LaserPower".equals(f.getName())) {
                            String d29 = map.get("d29") == null ? "" : map.get("d29").toString();
                            if (d29.equals("1")) {
                                f.set(jgReportDataDto, "6500");
                            } else {
                                f.set(jgReportDataDto, "0");
                            }
                        } else {
                            f.set(jgReportDataDto, value);
                        }
                    }

                }
                sites.put(f.getName(), f.get(jgReportDataDto) == null ? "0" : f.get(jgReportDataDto).toString());
                sites.put("ts", String.valueOf(millis));
                allDto.add(sites);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                allDto.add(site);
                reportDto.put("reported", allDto);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", allDto);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }

    /**
     * 数控龙门铣 已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     *
     * @param comparison
     * @param deviceId
     * @param lmxReportDataDto
     * @param bjhMap
     * @param bjxxMap
     * @return
     */
    public Map<String, Object> lmxSendString(Map<String, List<String>> comparison, String
            deviceId, LmxReportDataDto lmxReportDataDto, Map<String, Object> bjhMap, Map<String, String> bjxxMap) {
        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = lmxReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if ("DeviceID".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getDeviceID());
                } else if ("NcVer".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getNcVer());
                } else if ("Axes".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getAxes());
                } else if ("SpinNum".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getSpinNum());
                } else if ("MaxSpeed".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getMaxSpeed());
                } else if ("DeviceName".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getDeviceName());
                } else if ("DeviceBrand".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getDeviceBrand());
                } else if ("CompanyNo".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getCompanyNo());
                } else if ("factoryNo".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getFactoryNo());
                } else if ("AssetNo".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getAssetNo());
                } else if ("CncType".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getCncType());
                } else if ("DeviceType".equals(f.getName())) {
                    f.set(lmxReportDataDto, lmxReportDataDto.getDeviceType());
                } else {
                    if (ObjectUtils.isEmpty(map)) {
                        if ("Status".equals(f.getName())) {
                            f.set(lmxReportDataDto, "4");
                        } else {
                            f.set(lmxReportDataDto, "0");
                        }
                    } else {
                        List<String> columnList = comparison.get(f.getName());
                        if (!ObjectUtils.isEmpty(columnList)) {
                            String value = ObjectUtils.isEmpty(map.get(columnList.get(0))) ? "0" : map.get(columnList.get(0)).toString();
                            if ("AxisName".equals(f.getName())) {
                                Object o0 = map.get(columnList.get(0)) == null ? "0" : map.get(columnList.get(0));
                                Object o1 = map.get(columnList.get(1)) == null ? "0" : map.get(columnList.get(1));
                                Object o2 = map.get(columnList.get(2)) == null ? "0" : map.get(columnList.get(2));
                                Object o3 = map.get(columnList.get(3)) == null ? "0" : map.get(columnList.get(3));
                                String zb = o0 + "|" + o1 + "|" + o2 + "|" + o3;
                                f.set(lmxReportDataDto, zb);
                            } else if ("MachPos".equals(f.getName()) || "AbsPos".equals(f.getName()) || "RelPos".equals(f.getName())) {
                                Object o0 = map.get(columnList.get(0)) == null ? "0" : map.get(columnList.get(0));
                                Object o1 = map.get(columnList.get(1)) == null ? "0" : map.get(columnList.get(1));
                                String zb = o0 + "|" + o1;
                                f.set(lmxReportDataDto, zb);
                            } else if ("Status".equals(f.getName())) {
                                //直接读取d22程序运行状态
                                String status = map.get("d22") == null || map.get("d22").equals("") ? "" : map.get("d22").toString();
                                if (status.equals("3")) {  //运行
                                    f.set(lmxReportDataDto, "1");
                                } else {
                                    f.set(lmxReportDataDto, "2");
                                }
                            } else if ("Emg".equals(f.getName())) {
                                String txt = map.get(comparison.get(f.getName()).get(0)) == null ? "" : map.get(comparison.get(f.getName()).get(0)).toString();
                                if ("False".equals(txt)) {
                                    txt = "0";
                                } else if ("True".equals(txt)) {
                                    txt = "1";
                                } else {
                                    txt = "0";
                                }
                                f.set(lmxReportDataDto, txt);
                            } else if ("CutTime".equals(f.getName()) || "CycSec".equals(f.getName())) {
                                String date = map.get(columnList.get(0)) == null ? "0" : map.get(columnList.get(0)).toString();
                                if (date.contains(".")) {
                                    int indexOf = date.indexOf(".");
                                    date = date.substring(0, indexOf);
                                }
                                f.set(lmxReportDataDto, date);
                            } else {
                                f.set(lmxReportDataDto, value);
                            }
                        } else {
                            f.set(lmxReportDataDto, "0");
                        }
                    }
                }

                Sites2.put(f.getName(), f.get(lmxReportDataDto) != null ? f.get(lmxReportDataDto).toString() : "0");
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                e.printStackTrace();
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                bjhMap.put("reported", list);
                bjhMap.put("edgeTime", millis);
                return bjhMap;
            }
        }
        bjhMap.put("reported", list);
        bjhMap.put("edgeTime", millis);
        return bjhMap;
    }

    /**
     * 数控平面钻  已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     *
     * @param comparison
     * @param deviceId
     * @param pmzReportDataDto
     * @param bjhMap
     * @return
     */
    public Map<String, Object> pmzSendString(Map<String, List<String>> comparison, String
            deviceId, PmzReportDataDto pmzReportDataDto, Map<String, Object> bjhMap) {
        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = pmzReportDataDto.getClass().getDeclaredFields();
        System.out.println(pmzReportDataDto.toString() + "=0");
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if ("DeviceID".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceID());
                } else if ("CompanyNo".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getCompanyNo());
                } else if ("factoryNo".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getFactoryNo());
                } else if ("AssetNo".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getAssetNo());
                } else if ("DeviceName".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceName());
                } else if ("DeviceType".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceType());
                } else if ("CncType".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getCncType());
                } else if ("DeviceBrand".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceBrand());
                } else if ("NcVer".equals(f.getName())) {
                    f.set(pmzReportDataDto, pmzReportDataDto.getNcVer());
                } else {
                    if (ObjectUtils.isEmpty(map)) {
                        if ("Status".equals(f.getName())) {
                            f.set(pmzReportDataDto, 4);
                        } else {
                            f.set(pmzReportDataDto, 0);
                        }
                    } else {
                        List<String> columnList = comparison.get(f.getName());
                        if (!ObjectUtils.isEmpty(columnList)) {
                            String value = ObjectUtils.isEmpty(map.get(columnList.get(0))) ? "0" : map.get(columnList.get(0)).toString();
                            if ("Status".equals(f.getName())) {
                                //原设备上传的几个判断状态的值不稳定，当前直接读取d17程序运行状态
                                String s = map.get("d17") == null || map.get("d17").equals("") ? "" : map.get("d17").toString();
                                if (s.equals("3")) {  //运行
                                    f.set(pmzReportDataDto, "1");
                                } else {
                                    f.set(pmzReportDataDto, "2");
                                }
                            } else if ("CutTime".equals(f.getName()) || "CycSec".equals(f.getName())) { //处理上报数据类型（当前上报切削时间，加工时间为int型）
                                String time = map.get(columnList.get(0)) == null || map.get(columnList.get(0)).equals("") ? "0" : map.get(columnList.get(0)).toString();
                                if (time.contains(".")) {
                                    int indexOf = time.indexOf(".");
                                    time = time.substring(0, indexOf);
                                }
                                f.set(pmzReportDataDto, time);
                            } else {
                                f.set(pmzReportDataDto, value);
                            }
                        } else {
                            f.set(pmzReportDataDto, "0");
                        }

                    }
                }
                Sites2.put(f.getName(), f.get(pmzReportDataDto).toString());
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                e.printStackTrace();
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                bjhMap.put("reported", list);
                bjhMap.put("edgeTime", millis);
                return bjhMap;
            }
        }
        bjhMap.put("reported", list);
        bjhMap.put("edgeTime", millis);
        return bjhMap;
    }


//    public Map<String, Object> pmzSendString(Map<String, List<String>> comparison, String
//            deviceId, PmzReportDataDto pmzReportDataDto, Map<String, Object> bjhMap) {
//        Map map = findMongo(deviceId);
//        long millis = Calendar.getInstance().getTimeInMillis();
//        //处理实体类在每个字段加上时间
//        List<Map<String, String>> list = new ArrayList<>();
//        Field[] fields = pmzReportDataDto.getClass().getDeclaredFields();
//        for (int i = 0; i < fields.length; i++) {
//            Map<String, String> Sites2 = new HashMap<>();
//            Field f = fields[i];
//            f.setAccessible(true);
//            try {
//                if ("DeviceID".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceID());
//                } else if ("CompanyNo".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getCompanyNo());
//                } else if ("factoryNo".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getFactoryNo());
//                } else if ("AssetNo".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getAssetNo());
//                } else if ("DeviceName".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceName());
//                } else if ("DeviceType".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceType());
//                } else if ("CncType".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getCncType());
//                } else if ("DeviceBrand".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getDeviceBrand());
//                } else if ("NcVer".equals(f.getName())) {
//                    f.set(pmzReportDataDto, pmzReportDataDto.getNcVer());
//                }
//                if (ObjectUtils.isEmpty(map)) {
//                    if ("Status".equals(f.getName())) {
//                        f.set(pmzReportDataDto, "4");
//                    } else {
//                        f.set(pmzReportDataDto, "0");
//                    }
//                } else {
//                    long time = Long.valueOf(map.get("time").toString());
//                    List<String> columnList = comparison.get(f.getName());
//                    if (columnList != null) {
//                        if ((millis - time) > jugeTime) {
//                            if ("Status".equals(f.getName())) {
//                                f.set(pmzReportDataDto, "4");
//                            } else {
//                                f.set(pmzReportDataDto, "0");
//                            }
//                        } else {
//                            if ("Status".equals(f.getName())) {
//                                //直接读取d17程序运行状态
//                                String s = map.get("d17") == null || map.get("d17").equals("") ? "" : map.get("d17").toString();
//                                if (s.equals("3")) {  //运行
//                                    f.set(pmzReportDataDto, "1");
//                                } else if (s.equals("1") || s.equals("2") || s.equals("4") || s.equals("5")) {  //空闲
//                                    f.set(pmzReportDataDto, "2");
//                                } else {
//                                    f.set(pmzReportDataDto, "2");
//                                }
//                            } else if ("Alarm".equals(f.getName()) || "Emg".equals(f.getName())) {
//                                if (map.get(columnList.get(0)) == null || map.get(columnList.get(0)).equals("")) {
//                                    f.set(pmzReportDataDto, "0");
//                                } else {
//                                    f.set(pmzReportDataDto, map.get(comparison.get(f.getName()).get(0)));
//                                }
//                            } else if ("MainPgm".equals(f.getName()) || "CurPgm".equals(f.getName())) {
//                                if (map.get(columnList.get(0)) == null || map.get(columnList.get(0)).equals("")) {
//                                    f.set(pmzReportDataDto, "0");
//                                } else {
//                                    f.set(pmzReportDataDto, map.get(comparison.get(f.getName()).get(0)));
//                                }
//                            } else if ("CutTime".equals(f.getName()) || "CycSec".equals(f.getName())) {
//                                String date = map.get(columnList.get(0)) == null || map.get(columnList.get(0)).equals("") ? "0" : map.get(columnList.get(0)).toString();
//                                if (date.contains(".")) {
//                                    int indexOf = date.indexOf(".");
//                                    date = date.substring(0, indexOf);
//                                }
//                                f.set(pmzReportDataDto, date);
//                            } else if ("OvFeed".equals(f.getName()) || "OvSpin".equals(f.getName())
//                                    || "ActFeed".equals(f.getName()) || "FCode".equals(f.getName())
//                                    || "ActSpin".equals(f.getName()) || "PartCnt".equals(f.getName())
//                                    || "SpinLoad1".equals(f.getName())) {
//                                String s = comparison.get(f.getName()) == null ? "0" : comparison.get(f.getName()).get(0);
//                                f.set(pmzReportDataDto, map.get(s));
//                            }
//                        }
//                    }
//
//                }
//                Sites2.put(f.getName(), f.get(pmzReportDataDto) != null ? f.get(pmzReportDataDto).toString() : "");
//                Sites2.put("ts", String.valueOf(millis));
//                list.add(Sites2);
//            } catch (Exception e) {
//                Map<String, String> site = new HashMap<>();
//                site.put("Status", "2");
//                site.put("ts", String.valueOf(millis));
//                list.add(site);
//                bjhMap.put("reported", list);
//                bjhMap.put("edgeTime", millis);
//                return bjhMap;
//            }
//        }
//        bjhMap.put("reported", list);
//        bjhMap.put("edgeTime", millis);
//        return bjhMap;
//    }


    /**
     * 校平机   已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     *
     * @param comparison
     * @param deviceId
     * @param xpjReportDataDto
     * @param reportDto
     * @return
     */
    public Map<String, Object> xpjSendString(Map<String, String> comparison, String deviceId, XpjReportDataDto
            xpjReportDataDto, Map<String, Object> reportDto) {

        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = xpjReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {
                    if ("Status".equals(f.getName())) {
                        f.set(xpjReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(xpjReportDataDto, xpjReportDataDto.getNcVer());
                    } else {
                        f.set(xpjReportDataDto, "");
                    }
                } else {
                    long time = Long.valueOf(map.get("time").toString());
                    if (map.get(comparison.get(f.getName())) != null) {
                        if ((millis - time) > jugeTime) {
                            f.set(xpjReportDataDto, "");
                            if ("Status".equals(f.getName())) {
                                f.set(xpjReportDataDto, "4");
                            }
                        } else if ("Status".equals(f.getName())) {
                            String status = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                            if (status.equals("1") || status.equals("2") || status.equals("4")) {
                                f.set(xpjReportDataDto, status);
                            } else if (status.equals("3")) {  //客户要求故障显示待机
                                f.set(xpjReportDataDto, "2");
                            } else if (status.equals("")) {  //客户要求空显示关机
                                f.set(xpjReportDataDto, "4");
                            } else {
                                f.set(xpjReportDataDto, "2");
                            }
                        } else if ("Alarm".equals(f.getName())) {
                            String alarm = map.get(comparison.get(f.getName())) == null ? "" : map.get(comparison.get(f.getName())).toString();
                            if (alarm.equals("0")) {
                                f.set(xpjReportDataDto, "0");
                            } else {
                                f.set(xpjReportDataDto, "1");
                            }
                        } else {
                            f.set(xpjReportDataDto, map.get(comparison.get(f.getName())));
                        }
                    } else {
                        if ("Status".equals(f.getName())) {
                            f.set(xpjReportDataDto, "4");
                        }
                    }
                }
                Sites2.put(f.getName(), f.get(xpjReportDataDto) != null ? f.get(xpjReportDataDto).toString() : "");
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);

            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }


    /**
     * 梅塞尔52/53  已处理状态 异常和待机都显示2  状态值空和30秒内没上报数据显示4，执行显示1  （客户要求不要显示3）
     *
     * @param comparison
     * @param deviceId
     * @param dlzReportDataDto
     * @param reportDto
     * @return
     */
    public Map<String, Object> msrSendString(Map<String, List<String>> comparison, String
            deviceId, DlzReportDataDto dlzReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = dlzReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> sites = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if ("DeviceID".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getDeviceID());
                } else if ("CompanyNo".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getCompanyNo());
                } else if ("factoryNo".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getFactoryNo());
                } else if ("AssetNo".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getAssetNo());
                } else if ("DeviceName".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getDeviceName());
                } else if ("DeviceBrand".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getDeviceBrand());
                } else if ("DeviceType".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getDeviceType());
                } else if ("CncType".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getCncType());
                } else if ("NcVer".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getNcVer());
                } else if ("ElePowerType".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getElePowerType());
                } else if ("MaxIdleSpeed".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getMaxIdleSpeed());
                } else if ("MaxCutSpeed".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getMaxCutSpeed());
                } else if ("CutRange".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getCutRange());
                } else if ("CutGunNo".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getCutGunNo());
                } else if ("AxisTrip".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getAxisTrip());
                } else if ("PosAcc".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getPosAcc());
                } else if ("WorkSize".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getWorkSize());
                } else if ("CutGasType".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getCutGasType());
                } else if ("ProGasType".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getProGasType());
                } else if ("AxisName".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getAxisName());
                } else if ("SerNum".equals(f.getName())) {
                    f.set(dlzReportDataDto, dlzReportDataDto.getSerNum());
                } else {
                    if (ObjectUtils.isEmpty(map)) {
                        if ("Status".equals(f.getName())) {
                            f.set(dlzReportDataDto, "4");
                        } else {
                            f.set(dlzReportDataDto, "0");
                        }
                    } else {
                        List<String> columnList = comparison.get(f.getName());
                        if (!ObjectUtils.isEmpty(columnList)) {
                            String value = ObjectUtils.isEmpty(map.get(columnList.get(0))) ? "0" : map.get(columnList.get(0)).toString();
                            //判断设备是否关机
                            if ("Status".equals(f.getName())) {
                                String d23 = map.get("d23") == null ? "0" : map.get("d23").toString();
                                String d24 = map.get("d24") == null ? "0" : map.get("d24").toString();
                                //判断设备是否正在切割
                                if (d23.equals("True") && d24.equals("False")) {
                                    f.set(dlzReportDataDto, "1");
                                } else if (d23.equals("False") && d24.equals("True")) {  //判断设备是否空闲
                                    f.set(dlzReportDataDto, "2");
                                } else {
                                    f.set(dlzReportDataDto, "2"); //其他情况也显示空闲状态
                                }
                            }else if ("GasFlow".equals(f.getName())){
                                String d22 = map.get("d22") == null ? "0" : map.get("d22").toString();
                                f.set(dlzReportDataDto, d22);
                            } else if ("Voltage".equals(f.getName())) {
                                String d23 = map.get("d23") == null ? "False" : map.get("d23").toString();
                                String d24 = map.get("d24") == null ? "False" : map.get("d24").toString();
                                if (d23.equals("True") && d24.equals("False")) {
                                    f.set(dlzReportDataDto, "380");
                                } else {
                                    f.set(dlzReportDataDto, "0");
                                }
                            }
//                    //目前 急停,产量,气体流量采集不到(暂时默认为0)
////                            else if ("Emg".equals(f.getName()) || "PartCnt".equals(f.getName()) || "GasFlow".equals(f.getName()) || "Alarm".equals(f.getName())) {
////                                f.set(dlzReportDataDto, "0");
////                            }
                            //TODO
                            else if ("AbsPos".equals(f.getName())) {
                                List<String> absPos1PosList = comparison.get("AbsPos");
                                String absPos = "";
                                String s0 = map.get(absPos1PosList.get(0)) == null ? "0" : map.get(absPos1PosList.get(0)).toString();
                                String s1 = map.get(absPos1PosList.get(1)) == null ? "0" : map.get(absPos1PosList.get(1)).toString();
                                absPos = s0 + "|" + (s1.split(","))[0];

                                f.set(dlzReportDataDto, absPos);
                            } else if ("NcStatus".equals(f.getName())) {
                                List<String> ncStatusList = comparison.get("NcStatus");
                                String s = map.get(ncStatusList.get(0)) == null ? "" : map.get(ncStatusList.get(0)).toString();
                                if (s.equals("True")) {
                                    f.set(dlzReportDataDto, "1");
                                } else {
                                    f.set(dlzReportDataDto, "0");
                                }
                            } else if ("CutStatus".equals(f.getName())) {
                                List<String> cutStatusList = comparison.get("CutStatus");
                                String s = map.get(cutStatusList.get(0)) == null ? "" : map.get(cutStatusList.get(0)).toString();
                                if (s.toLowerCase().equals("true")) {
                                    f.set(dlzReportDataDto, "1");
                                } else {
                                    f.set(dlzReportDataDto, "0");
                                }
                            } else if ("ArcStrikeTime".equals(f.getName())) {
                                String d23 = map.get("d23") == null ? "False" : map.get("d23").toString();
                                String d24 = map.get("d24") == null ? "False" : map.get("d24").toString();
                                //判断设备是否正在切割
                                if (d23.equals("True") && d24.equals("False")) {
                                    List<String> cutStatusList = comparison.get("ArcStrikeTime");
                                    String s = map.get(cutStatusList.get(0)) == null ? "0" : map.get(cutStatusList.get(0)).toString();
                                    f.set(dlzReportDataDto, s);
                                } else {
                                    f.set(dlzReportDataDto, "0");
                                }
                            } else if ("ArcVoltage".equals(f.getName())) {
                                String d23 = map.get("d23") == null ? "0" : map.get("d23").toString();
                                String d24 = map.get("d24") == null ? "0" : map.get("d24").toString();
                                //判断设备是否正在切割
                                if (d23.equals("True") && d24.equals("False")) {
                                    List<String> cutStatusList = comparison.get("ArcVoltage");
                                    String s = map.get(cutStatusList.get(0)) == null ? "0" : map.get(cutStatusList.get(0)).toString();
                                    f.set(dlzReportDataDto, s);
                                } else {
                                    f.set(dlzReportDataDto, "0");
                                }
                            } else if ("CycSec".equals(f.getName())) {
                                    String[] split = value.split("-");
                                    if (split.length == 6) {
                                        Integer week = Integer.parseInt(split[0].substring(0, split[0].length() - 4));
                                        Integer day = Integer.parseInt(split[1].substring(0, split[1].length() - 3));
                                        Integer hour = Integer.parseInt(split[2].substring(0, split[2].length() - 4));
                                        Integer min = Integer.parseInt(split[3].substring(0, split[3].length() - 3));
                                        f.set(dlzReportDataDto, week * 7 * 24 * 60 * 60 + day * 24 * 60 * 60 + hour * 60 * 60 + min * 60 + "");
                                    } else {
                                        f.set(dlzReportDataDto, value);
                                    }
                            } else {
                                System.out.println(f.getName()+"="+i);
                                f.set(dlzReportDataDto, value);
                            }
                        } else {

                            f.set(dlzReportDataDto, "0");
                        }
                    }
                }
                sites.put(f.getName(), f.get(dlzReportDataDto) != null ? f.get(dlzReportDataDto).toString() : "0");
                sites.put("ts", String.valueOf(millis));
                list.add(sites);
            } catch (Exception e) {
                e.printStackTrace();
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }
//    public Map<String, Object> msrSendString(Map<String, List<String>> comparison, String
//            deviceId, DlzReportDataDto dlzReportDataDto, Map<String, Object> reportDto) {
//        Map map = findMongo(deviceId);
//        long millis = Calendar.getInstance().getTimeInMillis();
//        //处理实体类在每个字段加上时间
//        List<Map<String, String>> list = new ArrayList<>();
//        Field[] fields = dlzReportDataDto.getClass().getDeclaredFields();
//        for (int i = 0; i < fields.length; i++) {
//            Map<String, String> sites = new HashMap<>();
//            Field f = fields[i];
//            f.setAccessible(true);
//            try {
//                if (EmptyUtil.isEmpty(map)) {
//                    if ("DeviceID".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getDeviceID());
//                    } else if ("CompanyNo".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getCompanyNo());
//                    } else if ("factoryNo".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getFactoryNo());
//                    } else if ("AssetNo".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getAssetNo());
//                    } else if ("DeviceName".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getDeviceName());
//                    } else if ("DeviceBrand".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getDeviceBrand());
//                    } else if ("DeviceType".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getDeviceType());
//                    } else if ("CncType".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getCncType());
//                    } else if ("NcVer".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getNcVer());
//                    } else if ("ElePowerType".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getElePowerType());
//                    } else if ("MaxIdleSpeed".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getMaxIdleSpeed());
//                    } else if ("MaxCutSpeed".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getMaxCutSpeed());
//                    } else if ("CutRange".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getCutRange());
//                    } else if ("CutGunNo".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getCutGunNo());
//                    } else if ("AxisTrip".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getAxisTrip());
//                    } else if ("PosAcc".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getPosAcc());
//                    } else if ("WorkSize".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getWorkSize());
//                    } else if ("CutGasType".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getCutGasType());
//                    } else if ("ProGasType".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getProGasType());
//                    } else if ("AxisName".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getAxisName());
//                    } else if ("SerNum".equals(f.getName())) {
//                        f.set(dlzReportDataDto, dlzReportDataDto.getSerNum());
//                    } else if ("Status".equals(f.getName())) {
//                        f.set(dlzReportDataDto, "4");
//                    } else {
//                        f.set(dlzReportDataDto, "0");
//                    }
//                }else {
//                    List<String> values = comparison.get(f.getName());
//                        if ("DeviceID".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getDeviceID());
//                        } else if ("CompanyNo".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getCompanyNo());
//                        } else if ("factoryNo".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getFactoryNo());
//                        } else if ("AssetNo".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getAssetNo());
//                        } else if ("DeviceName".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getDeviceName());
//                        } else if ("DeviceBrand".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getDeviceBrand());
//                        } else if ("DeviceType".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getDeviceType());
//                        } else if ("CncType".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getCncType());
//                        } else if ("NcVer".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getNcVer());
//                        } else if ("ElePowerType".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getElePowerType());
//                        } else if ("MaxIdleSpeed".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getMaxIdleSpeed());
//                        } else if ("MaxCutSpeed".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getMaxCutSpeed());
//                        } else if ("CutRange".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getCutRange());
//                        } else if ("CutGunNo".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getCutGunNo());
//                        } else if ("AxisTrip".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getAxisTrip());
//                        } else if ("PosAcc".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getPosAcc());
//                        } else if ("WorkSize".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getWorkSize());
//                        } else if ("CutGasType".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getCutGasType());
//                        } else if ("ProGasType".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getProGasType());
//                        } else if ("AxisName".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getAxisName());
//                        } else if ("SerNum".equals(f.getName())) {
//                            f.set(dlzReportDataDto, dlzReportDataDto.getSerNum());
//                        }
//                    if (!EmptyUtil.isEmpty(values)){
//                         if ("Status".equals(f.getName())) {
//                            String d23 = map.get(values.get(0)) == null ? "0" : map.get(values.get(0)).toString();
//                            String d24 = map.get(values.get(1)) == null ? "0" : map.get(values.get(1)).toString();
//                            //判断设备是否正在切割
//                            if (d23.equals("True") && d24.equals("False")) {
//                                f.set(dlzReportDataDto, "1");
//                            } else if (d23.equals("False") && d24.equals("True")) {  //判断设备是否空闲
//                                f.set(dlzReportDataDto, "2");
//                            } else {
//                                f.set(dlzReportDataDto, "2"); //其他情况也显示空闲状态
//                            }
//                        }
//                        else if ("Voltage".equals(f.getName())) {
//                            String d23 = map.get("d23") == null ? "False" : map.get("d23").toString();
//                            String d24 = map.get("d24") == null ? "False" : map.get("d24").toString();
//                            if (d23.equals("True") && d24.equals("False")) {
//                                f.set(dlzReportDataDto, "380");
//                            } else {
//                                f.set(dlzReportDataDto, "0");
//                            }
//                        }
//                        else if ("AbsPos".equals(f.getName())) {
//                            List<String> absPos1PosList = comparison.get("AbsPos");
//                            String absPos = "";
//                            String s0 = map.get(absPos1PosList.get(0)) == null ? "0" : map.get(absPos1PosList.get(0)).toString();
//                            String s1 = map.get(absPos1PosList.get(1)) == null ? "0" : map.get(absPos1PosList.get(1)).toString();
//                            absPos = s0 + "|" + (s1.split(","))[0];
//
//                            f.set(dlzReportDataDto, absPos);
//                        }
//                        else if ("NcStatus".equals(f.getName())) {
//                            List<String> ncStatusList = comparison.get("NcStatus");
//                            String s = map.get(ncStatusList.get(0)) == null ? "" : map.get(ncStatusList.get(0)).toString();
//                            if (s.equals("True")) {
//                                f.set(dlzReportDataDto, "1");
//                            } else {
//                                f.set(dlzReportDataDto, "0");
//                            }
//                        } else if ("CutStatus".equals(f.getName())) {
//                            List<String> cutStatusList = comparison.get("CutStatus");
//                            String s = map.get(cutStatusList.get(0)) == null ? "" : map.get(cutStatusList.get(0)).toString();
//                            if (s.toLowerCase().equals("true")) {
//                                f.set(dlzReportDataDto, "1");
//                            } else {
//                                f.set(dlzReportDataDto, "0");
//                            }
//                        } else if ("ArcStrikeTime".equals(f.getName())) {
//                            String d23 = map.get("d23") == null ? "False" : map.get("d23").toString();
//                            String d24 = map.get("d24") == null ? "False" : map.get("d24").toString();
//                            //判断设备是否正在切割
//                            if (d23.equals("True") && d24.equals("False")) {
//                                List<String> cutStatusList = comparison.get("ArcStrikeTime");
//                                String s = map.get(cutStatusList.get(0)) == null ? "0" : map.get(cutStatusList.get(0)).toString();
//                                f.set(dlzReportDataDto, s);
//                            } else {
//                                f.set(dlzReportDataDto, 0);
//                            }
//                        }
//                        else if ("CycSec".equals(f.getName())) {
//                            String[] split = map.get(values.get(0)).toString().split("-");
//                            if (split.length == 6) {
//                                Integer week = Integer.parseInt(split[0].substring(0, split[0].length() - 4));
//                                Integer day = Integer.parseInt(split[1].substring(0, split[1].length() - 3));
//                                Integer hour = Integer.parseInt(split[2].substring(0, split[2].length() - 4));
//                                Integer min = Integer.parseInt(split[3].substring(0, split[3].length() - 3));
//                                f.set(dlzReportDataDto, week * 7 * 24 * 60 * 60 + day * 24 * 60 * 60 + hour * 60 * 60 + min * 60 + "");
//                            } else {
//                                f.set(dlzReportDataDto, map.get(values.get(0)));
//                            }
//                        } else {
//                            f.set(dlzReportDataDto, map.get(f.getName()));
//                        }
//                    }
//                }
//                sites.put(f.getName(), f.get(dlzReportDataDto) != null ? f.get(dlzReportDataDto).toString() : "0");
//                sites.put("ts", String.valueOf(millis));
//                list.add(sites);
//            } catch (Exception e) {
//                e.printStackTrace();
//                Map<String, String> site = new HashMap<>();
//                site.put("Status", "2");
//                site.put("ts", String.valueOf(millis));
//                list.add(site);
//                reportDto.put("reported", list);
//                reportDto.put("edgeTime", millis);
//                return reportDto;
//            }
//        }
//        reportDto.put("reported", list);
//        reportDto.put("edgeTime", millis);
//        return reportDto;
//    }


    /**
     * 智能行车
     */
    public Map<String, Object> zlhcSendString(Map<String, String> comparison, String deviceId, ZlhcReportDataDto
            zlhcReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = zlhcReportDataDto.getClass().getDeclaredFields();

        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {
                    if ("Status".equals(f.getName())) {
                        f.set(zlhcReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(zlhcReportDataDto, zlhcReportDataDto.getNcVer());
                    } else {
                        f.set(zlhcReportDataDto, "");
                    }
                } else {
                    long time = Long.valueOf(map.get("time").toString());
                    if ((millis - time) > jugeTime) {
                        if ("Status".equals(f.getName())) {
                            f.set(zlhcReportDataDto, "4");
                        }
                    } else {
                        if ("Alarm".equals(f.getName())) {
//                            String d20 = map.get("d20") == null ? "" : map.get("d20").toString();
                            String alarm = map.get("d17") == null ? "0" : map.get("d17").toString();
                            if ("3".equals(alarm)) {
                                f.set(zlhcReportDataDto, "1");
                            } else {
                                f.set(zlhcReportDataDto, "0");
                            }
                        } else if ("LiftWeight".equals(f.getName()) || "LiftHeight".equals(f.getName()) || "LiftSpeed".equals(f.getName())) {
                            String d = map.get(comparison.get(f.getName())) == null ? "0" : map.get(comparison.get(f.getName())).toString();
                            f.set(zlhcReportDataDto, d);
                        } else if ("Status".equals(f.getName())) {
                            String status = map.get("d17") == null ? "" : map.get("d17").toString();
                            if ("1".equals(status) || "2".equals(status)) {
                                f.set(zlhcReportDataDto, "1");
                            } else if ("0".equals(status) || "3".equals(status)) {
                                f.set(zlhcReportDataDto, "2");
                            } else if ("4".equals(status)) {
                                f.set(zlhcReportDataDto, "4");
                            } else {
                                f.set(zlhcReportDataDto, "2");
                            }
                        }
                    }
                }
                Sites2.put(f.getName(), f.get(zlhcReportDataDto) != null ? f.get(zlhcReportDataDto).toString() : "");
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (IllegalAccessException e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }

    /**
     * 其他下料
     */
    public Map<String, Object> qtxlSendString(Map<String, String> comparison, String deviceId, QtxlReportDataDto
            qtxlReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo(deviceId);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> list = new ArrayList<>();
        Field[] fields = qtxlReportDataDto.getClass().getDeclaredFields();

        for (int i = 0; i < fields.length; i++) {
            Map<String, String> Sites2 = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if (ObjectUtils.isEmpty(map)) {

                    if ("Status".equals(f.getName())) {
                        f.set(qtxlReportDataDto, "4");
                    } else if ("DeviceID".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getDeviceID());
                    } else if ("CompanyNo".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getCompanyNo());
                    } else if ("factoryNo".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getFactoryNo());
                    } else if ("AssetNo".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getAssetNo());
                    } else if ("DeviceName".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getDeviceName());
                    } else if ("DeviceType".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getDeviceType());
                    } else if ("CncType".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getCncType());
                    } else if ("NcVer".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getNcVer());
                    } else if ("DeviceBrand".equals(f.getName())) {
                        f.set(qtxlReportDataDto, qtxlReportDataDto.getDeviceBrand());
                    } else {
                        f.set(qtxlReportDataDto, "");
                    }
                } else {
                    /*long time = ((Date) map.get("time")).getTime();*/
                    long time = Long.valueOf(map.get("time").toString());
                    /*"Status".equals(f.getName())*/
                    /*if (f.get(qtxlReportDataDto) == null) {*/
                    if (map.get(comparison.get(f.getName())) != null) {
                        if ((millis - time) > jugeTime) {
                            f.set(qtxlReportDataDto, "");
                            if ("Status".equals(f.getName())) {
                                f.set(qtxlReportDataDto, "4");
                            }
                        } else {
                            String txt = map.get(comparison.get(f.getName())).toString();
                            if ("d1".equals(comparison.get(f.getName()))) {
                                if (txt.equals("1") || txt.equals("2") || txt.equals("3") || txt.equals("4")) {
                                    txt = String.valueOf(Double.valueOf(txt).intValue());
                                } else {
                                    txt = "4";
                                }
                            }
                            if ("d2".equals(comparison.get(f.getName()))) {
                                if ("true".equals(txt)) {
                                    txt = "1";
                                } else if ("false".equals(txt)) {
                                    txt = "0";
                                }
                            }
                            f.set(qtxlReportDataDto, txt);
                        }
                    } else {
                        if ("Status".equals(f.getName())) {
                            f.set(qtxlReportDataDto, "4");
                        }
                    }
                }
                /*}*/
                String s = "";
                if (f.get(qtxlReportDataDto) != null) {
                    s = f.get(qtxlReportDataDto).toString();
                }
                Sites2.put(f.getName(), s);
                // Sites2.put(f.getName(), f.get(qtxlReportDataDto).toString());
                Sites2.put("ts", String.valueOf(millis));
                list.add(Sites2);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                list.add(site);
                reportDto.put("reported", list);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", list);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }

    private void getMseNull(Field f, DlzReportDataDto dlzReportDataDto) throws IllegalAccessException {
        if ("Status".equals(f.getName())) {
            f.set(dlzReportDataDto, "4");
        } else if ("Emg".equals(f.getName())) {
            f.set(dlzReportDataDto, "1");
        } else if ("AxisName".equals(f.getName())) {
            f.set(dlzReportDataDto, "X|Y|Z");
        } else if ("MachPos".equals(f.getName())) {
            f.set(dlzReportDataDto, "|");
        } else if ("CutGasType".equals(f.getName())) {
            f.set(dlzReportDataDto, "2");
        } else if ("ProGasType".equals(f.getName())) {
            f.set(dlzReportDataDto, "1");
        } else if ("Voltage".equals(f.getName())) {
            f.set(dlzReportDataDto, "380V");
        } else {
            f.set(dlzReportDataDto, "");
        }
    }

    private void getLmxNull(Field f, LmxReportDataDto lmxReportDataDto) throws IllegalAccessException {
        if ("Status".equals(f.getName())) {
            f.set(lmxReportDataDto, "4");
        } else if ("AxisName".equals(f.getName())) {
            f.set(lmxReportDataDto, "Z1|Z2|Z3|Z4");
        } else if ("MachPos".equals(f.getName()) || "ABSPos".equals(f.getName()) || "RelPos".equals(f.getName())) {
            f.set(lmxReportDataDto, "X|Y");
        } else {
            f.set(lmxReportDataDto, "");
        }
    }

    private Map findMongo(String deviceId) {
        String tableName = "";
        Map map = null;
        try {
            DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
            String yearMonth = LocalDate.now().format(fmDate);
            tableName = deviceId + "01" + yearMonth;
            //从mongodb查询
            Query query = new Query();
            query.limit(1);
            query.with(Sort.by(
                    Sort.Order.desc("time")
            ));
            List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, tableName);
            if (!ObjectUtils.isEmpty(objectList)) {
                JSONObject jsonObject = objectList.get(0);
                map = jsonObject.toJavaObject(Map.class);
            }
            //mongdb最新数据时间
            Long time = Long.valueOf(map.get("time").toString());
            //当前时间
            long millis = Calendar.getInstance().getTimeInMillis();
            //如果当前时间-最新上报数据的时间<设置关机范围，那么直接给
            if ((millis - time) < jugeTime) {
                return map;
            } else {
                return null;
            }

        } catch (Exception e) {
            return map;
        }
    }

    private Map findMongo1(String deviceId,int start,int end) {
        int i = (int)Math.ceil((double) start/50);
        int j =(int) Math.ceil((double) end/50);

        System.out.println();
        String tableName = "";
        Map map = null;
        DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
        String yearMonth = LocalDate.now().format(fmDate);
        for(int x = i; x<=j; x++){
            try {
                if(x<10){
                    tableName = deviceId + "0" +x + yearMonth;
                }else{
                    tableName = deviceId + x + yearMonth;
                }
                //从mongodb查询
                Query query = new Query();
                query.limit(1);
                query.with(Sort.by(
                        Sort.Order.desc("time")
                ));
                if(x==j){
                    for (int a=start;a<=end;a++){
                        query.fields().include("d"+a);
                    }
                }else{
                    for (int a=start;a<=x*50;a++){
                        query.fields().include("d"+a);
                    }
                }
                query.fields().include("time");
                List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, tableName);
                //mongdb最新数据时间
                Long time = Long.valueOf(objectList.get(0).toJavaObject(Map.class).get("time").toString());
                //当前时间
                long millis = Calendar.getInstance().getTimeInMillis();
                //如果当前时间-最新上报数据的时间<设置关机范围，那么直接给
                if ((millis - time) < jugeTime && !ObjectUtils.isEmpty(objectList)) {
                    JSONObject jsonObject = objectList.get(0);
                    if(!EmptyUtil.isEmpty(map)){
                        map.putAll(jsonObject.toJavaObject(Map.class));
                    }else{
                        map = jsonObject.toJavaObject(Map.class);
                    }
                }
            } catch (Exception e) {
                return map;
            }
        }
        return map;
    }

    /**
     * 机器人测试
     */
    public Map<String, Object> jqrSendString(Map<String, String> comparison, String deviceId, Jqr
            jgReportDataDto, Map<String, Object> reportDto) {
        Map map = findMongo1(deviceId,1,35);
        long millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, String>> allDto = new ArrayList<>();
        Field[] fields = jgReportDataDto.getClass().getDeclaredFields();
        for (int i = 0; i < fields.length; i++) {
            Map<String, String> sites = new HashMap<>();
            Field f = fields[i];
            f.setAccessible(true);
            try {
                if ("DeviceID".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceID());
                } else if ("CompanyNo".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getCompanyNo());
                } else if ("factoryNo".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getFactoryNo());
                } else if ("AssetNo".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getAssetNo());
                } else if ("DeviceName".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceName());
                } else if ("DeviceType".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getDeviceType());
                } else if ("CncType".equals(f.getName())) {
                    f.set(jgReportDataDto, jgReportDataDto.getCncType());
                }
                if("J1".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d1"));
                }
                if("J2".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d2"));
                }
                if("J3".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d3"));
                }
                if("J4".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d4"));
                }
                if("J5".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d5"));
                }
                if("J6".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d6"));
                }
                if("UP".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d7"));
                }
                if("UR".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d8"));
                }
                if("UW".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d9"));
                }
                if("UX".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d10"));
                }
                if("UY".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d11"));
                }
                if("UZ".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d12"));
                }
                if("WP".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d13"));
                }
                if("WR".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("14"));
                }
                if("WW".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d15"));
                }
                if("WX".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d16"));
                }
                if("WY".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d17"));
                }
                if("WZ".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d18"));
                }
                if("MainPgm".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d19"));
                }
                if("MainPgmMsg".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d20"));
                }
                if("CycSec".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d21"));
                }
                if("AirFlow".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d22"));
                }
                if("PaintSpeed".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d23"));
                }
                if("Mode".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d24"));
                }
                if("GunStatus".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d25"));
                }
                if("CurPgm".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d26"));
                }
                if("CurPgmMsg".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d28"));
                }
                if("Emg".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d29"));
                }
                if("Alarm".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d30"));
                }
                if("AlarmMsg".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d31"));
                }
                if("CurSeq".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d32"));
                }
                if("NcStatus".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d33"));
                }
                if("Status".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d34"));
                }
                if("PaintVoltage".equals(f.getName())){
                    f.set(jgReportDataDto, map.get("d35"));
                }

                sites.put(f.getName(), f.get(jgReportDataDto) == null ? "0" : f.get(jgReportDataDto).toString());
                sites.put("ts", String.valueOf(millis));
                allDto.add(sites);
            } catch (Exception e) {
                Map<String, String> site = new HashMap<>();
                site.put("Status", "2");
                site.put("ts", String.valueOf(millis));
                allDto.add(site);
                reportDto.put("reported", allDto);
                reportDto.put("edgeTime", millis);
                return reportDto;
            }
        }
        reportDto.put("reported", allDto);
        reportDto.put("edgeTime", millis);
        return reportDto;
    }
}
