package com.jln.system.web.action.mqtt.server.impl;

import com.alibaba.fastjson.JSONObject;
import com.jln.common.enums.MqttEnum;
import com.jln.system.web.action.mqtt.MqttStartClient;
import com.jln.system.web.action.mqtt.XBMqttDataUtil;
import com.jln.system.web.action.mqtt.mapper.ScadaBiMapper;

import com.jln.system.web.action.mqtt.pojo.vo.BldzCclmVo;
import com.jln.system.web.action.mqtt.server.SendMqttServer;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Service;

import java.io.*;
import java.util.*;

@Service
@Slf4j
public class SendMqttServerImpl implements SendMqttServer {
    @Autowired
    private MqttStartClient mqttStartClient;
    @Autowired
    private ScadaBiMapper scadaMapper;

    @Value("${jg.btqgjTxt}")
    private String btqgjTxt;

    @Value("${jqr.ptjqr1}")
    private String ptjqr1;

    @Value("${zlhc.xgjxcTxt}")
    private String xgjxcTxt;

    @Value("${qtxl.blxTxt}")
    private String blxTxt;


    @Value("${dlz.mse52Txt}")
    private String mse52Txt;


    @Value("${dlz.mse53Txt}")
    private String mse53Txt;


    @Value("${xxj.xpjTxt}")
    private String xpjTxt;


    @Value("${zwj.400zwjTxt}")
    private String zwj400Txt;


    @Value("${zwj.800zwjTxt}")
    private String zwj800Txt;


    @Value("${djpk.djpk01Txt}")
    private String djpk01Txt;


    @Value("${djpk.djpk02Txt}")
    private String djpk02Txt;


    @Value("${lmx.bjTxt}")
    private String lmxBjTxt;

    @Value("${lmx.bjxx}")
    private String bjxx;


    @Value("${pmz.bjTxt}")
    private String pmzBjTxt;

    @Value("${commonSk}")
    private String commonSk;
    @Value("${carcertPath}")
    private String carcertPath;

    @Value("${sleepTime}")
    private Long sleepTime;

    @Override
    public void sendMqtt() {
//        //解析sk文件
        //   String skFileValue = readSkFileToList(commonSk);
        MqttStartClient mq = new MqttStartClient();
        String skFileValue = mq.readSkFileToList(commonSk);
        JSONObject jsonObject = JSONObject.parseObject(skFileValue);
        Map<String, String> configParams = new HashMap<>();
        configParams.put(MqttEnum.MQTT_HOST.getMqttName(), jsonObject.getString("server"));
        String clientId = jsonObject.getString("version") + "." + jsonObject.getString("productType")
                + "." + jsonObject.getString("platform_id") + "." + jsonObject.getString("namespace")
                + "." + jsonObject.getString("productKey") + "." + jsonObject.getString("accessKey");
        configParams.put(MqttEnum.MQTT_CLIENTID.getMqttName(), clientId);
        configParams.put(MqttEnum.MQTT_USERNAME.getMqttName(), jsonObject.getString("accessKey"));
        configParams.put(MqttEnum.MQTT_PASSWORD.getMqttName(), jsonObject.getString("secretKey"));
        configParams.put(MqttEnum.MQTT_SSLROOT_CRTPATH.getMqttName(), carcertPath);
        configParams.put(MqttEnum.MQTT_SSLPROTOCOL.getMqttName(), MqttEnum.MQTT_TLS.getMqttName());
        String topic = "$SANY/gateway/pdev/sany/mdc/" + jsonObject.getString("accessKey") + "/data";
        configParams.put(MqttEnum.MQTT_TOPIC.getMqttName(), topic);

        XBMqttDataUtil xbMqttDataUtil = new XBMqttDataUtil(configParams);
        // TODO 奔腾-》激光   已处理
        /*new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Map<String, String> dongtaishuju = jgqgj("奔腾切割机");
                        if (dongtaishuju != null && dongtaishuju.size() > 0) {
                            mqttStartClient.jgStartLj(btqgjTxt, commonSk, dongtaishuju, "jgqgj", xbMqttDataUtil);
                        }
                        Thread.sleep(sleepTime);
                    } catch (InterruptedException e) {
                        continue;
                    }
                }
            }
        }, "jg-Thread").start();
        //板链线-》其他
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> blx = blx("板链线");
                if (blx != null && blx.size() > 0) {
                    mqttStartClient.blxStartLj(blxTxt, commonSk, blx, "blx", xbMqttDataUtil);
                }
            }
        }, "blx-Thread").start();
        //TODO 小杠机车行-》智能行车  已处理
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> xgjx = xgjx("小港机行车");
                if (xgjx != null && xgjx.size() > 0) {
                    mqttStartClient.znhcStartLj(xgjxcTxt, commonSk, xgjx, "xgjxc", xbMqttDataUtil);
                }
            }
        }, "znhc-Thread").start();
        //梅塞尔52-》等离子  以处理
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Map<String, List<String>> msedongtaizhi = mse("梅塞尔52");
                        if (msedongtaizhi != null && msedongtaizhi.size() > 0) {
                            mqttStartClient.msrStartLj(mse52Txt, commonSk, msedongtaizhi, "mse52", xbMqttDataUtil);
                        }
                        Thread.sleep(sleepTime);
                    } catch (InterruptedException e) {
                        continue;
                    }
                }
            }
        }, "msr52-Thread").start();
        //梅塞尔53-》等离子
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Map<String, List<String>> mse = mse("梅塞尔53");
                        if (mse != null && mse.size() > 0) {
                            mqttStartClient.msrStartLj(mse53Txt, commonSk, mse, "mse53", xbMqttDataUtil);
                        }
                        Thread.sleep(sleepTime);
                    } catch (InterruptedException e) {
                        continue;
                    }
                }
            }

        }, "msr53-Thread").start();
        //校平机  以处理
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> xpj = xpj("校平机");
                if (xpj != null && xpj.size() > 0) {
                    mqttStartClient.xpjStartLj(xpjTxt, commonSk, xpj, "xpj", xbMqttDataUtil);
                }
            }
        }, "xpj-Thread").start();
        //数控龙门铣
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Map<String, List<String>> lmx = lmx("数控龙门铣");
                        if (lmx != null && lmx.size() > 0) {
                            mqttStartClient.lmxStartLj(lmxBjTxt, commonSk, lmx, "sklmx", bjxx, xbMqttDataUtil);
                        }
                        Thread.sleep(sleepTime);
                    } catch (InterruptedException e) {
                        continue;
                    }
                }
            }
        }, "sklmx-Thread").start();

        //数控平面钻
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Map<String, List<String>> pmz = pmz("数控平面钻");
                        if (pmz != null && pmz.size() > 0) {
                            mqttStartClient.pmzStartLj(pmzBjTxt, commonSk, pmz, "skpmz", xbMqttDataUtil);
                        }
                        Thread.sleep(sleepTime);
                    } catch (InterruptedException e) {
                        continue;
                    }
                }
            }
        }, "skpmz-Thread").start();
        // TODO 400T折弯机 已处理
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> zwj = zwj("400折弯机");
                if (zwj != null && zwj.size() > 0) {
                    mqttStartClient.zwj400(zwj400Txt, commonSk, zwj, "400zwj", xbMqttDataUtil);
                }
            }
        }, "400zwj-Thread").start();
        //TODO 800T折弯机   已处理
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> zwj800 = zwj800("800折弯机");
                if (zwj800 != null && zwj800.size() > 0) {
                    mqttStartClient.zwj800(zwj800Txt, commonSk, zwj800, "800zwj", xbMqttDataUtil);
                }
            }
        }, "800zwj-Thread").start();
        //坡口机器人1
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> djpk = djpk01("大件坡口");
                if (djpk != null && djpk.size() > 0) {
                    mqttStartClient.djpk01StartLj(djpk01Txt, commonSk, djpk, "djpk", xbMqttDataUtil);
                }
            }
        }, "djpk01-Thread").start();

        //坡口机器人2
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<String, String> djpk = djpk02("大件坡口");
                if (djpk != null && djpk.size() > 0) {
                    mqttStartClient.djpk02StartLj(djpk02Txt, commonSk, djpk, "djpk", xbMqttDataUtil);
                }
            }
        }, "djpk02-Thread").start();*/

        // TODO 动臂斗杆底漆喷涂机器人1
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Map<String, String> dongtaishuju = jgqgj("正常数据设备");
                        if (dongtaishuju != null && dongtaishuju.size() > 0) {
                            mqttStartClient.jqr(ptjqr1, commonSk, dongtaishuju, "zhengchangshujushebei", xbMqttDataUtil);
                        }
                        Thread.sleep(sleepTime);
                    } catch (InterruptedException e) {
                        continue;
                    }
                }
            }
        }, "test-Thread").start();
    }

    public Map<String, String> djpk01(String name) {
        List<BldzCclmVo> djpkVos = scadaMapper.find(name);
        Map<String, String> djpkMap = new HashMap<>();
        for (BldzCclmVo djpkVo : djpkVos) {
            if (djpkVo != null) {
                if ("设备状态1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Status", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("急停1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Emg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("报警1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Alarm", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("AlarmMsg1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("AlarmMsg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("工作模式1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Mode", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1J1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J1", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1J2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J2", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1J3".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J3", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1J4".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J4", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1J5".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J5", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1J6".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J6", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("用户坐标1UX".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UX", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标1UY".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UY", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标1UZ".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UZ", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标1UW".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UW", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标1UP".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UP", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标1UR".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UR", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1UY".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UY", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1UZ".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UZ", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1UW".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UW", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1UP".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UP", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标1UR".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UR", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("世界坐标1WX".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WX", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标1WY".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WY", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标1WZ".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WZ", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标1WW".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WW", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标1WP".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WP", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标1WR".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WR", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("程序运行状态1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("NcStatus", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("主程序名称1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("MainPgm", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("主程序注释1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("MainPgmMsg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("当前程序名称1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurPgm", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("当前程序注释1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurPgmMsg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("作业时间1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CycSec", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("程序行号1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurSeq", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("当前程序块1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurNcBlk", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("控制柜型号1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CabType", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割电源型号1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("PowerType", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("气体压力1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("GasPressure", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割速度1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CutSpeed", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割电流1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Current", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割状态1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WorkStatus", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("气体流量1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("GasFlow", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("燃烧气体类型1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("BurnGas", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("引弧时间1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("ArcStrikeTime", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("弧压1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("ArcVoltage", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("隔缝补偿1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("GapOffset", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("工作电压1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Voltage", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("工作电流1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WorkCurrent", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
            }
        }
        return djpkMap;
    }

    public Map<String, String> djpk02(String name) {
        List<BldzCclmVo> djpkVos = scadaMapper.find(name);
        Map<String, String> djpkMap = new HashMap<>();
        for (BldzCclmVo djpkVo : djpkVos) {
            if (djpkVo != null) {
                if ("设备状态2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Status", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("急停2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Emg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("报警2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Alarm", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("报警信息2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("AlarmMsg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("工作模式2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Mode", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2J1".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J1", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2J2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J2", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2J3".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J3", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2J4".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J4", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2J5".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J5", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2J6".equals(djpkVo.getBlmc())) {
                    djpkMap.put("J6", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("用户坐标2UX".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UX", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标2UY".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UY", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标2UZ".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UZ", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标2UW".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UW", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标2UP".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UP", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("用户坐标2UR".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UR", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2UY".equals(djpkVo.getBlmc())) {
                    djpkMap.put("2UY", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2UZ".equals(djpkVo.getBlmc())) {
                    djpkMap.put("2UZ", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2UW".equals(djpkVo.getBlmc())) {
                    djpkMap.put("2UW", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2UP".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UP", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("角度坐标2UR".equals(djpkVo.getBlmc())) {
                    djpkMap.put("UR", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("世界坐标2WX".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WX", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标2WY".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WY", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标2WZ".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WZ", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标2WW".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WW", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标2WP".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WP", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("世界坐标2WR".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WR", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("程序运行状态2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("NcStatus", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("主程序名称2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("MainPgm", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("主程序注释2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("MainPgmMsg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("当前程序名称2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurPgm", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("当前程序注释2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurPgmMsg", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("作业时间2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CycSec", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("程序行号2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurSeq", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("当前程序块2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CurNcBlk", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("控制柜型号2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CabType", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割电源型号2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("PowerType", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("气体压力2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("GasPressure", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割速度2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("CutSpeed", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割电流2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Current", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("切割状态2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WorkStatus", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("气体流量2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("GasFlow", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("燃烧气体类型2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("BurnGas", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("引弧时间2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("ArcStrikeTime", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("弧压2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("ArcVoltage", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("隔缝补偿2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("GapOffset", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("工作电压2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("Voltage", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("工作电流2".equals(djpkVo.getBlmc())) {
                    djpkMap.put("WorkCurrent", djpkVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
            }
        }
        return djpkMap;
    }

    public Map<String, String> zwj(String name) {
        List<BldzCclmVo> zwjVos = scadaMapper.find(name);
        Map<String, String> zwjMap = new HashMap<>();
        for (BldzCclmVo zwjVo : zwjVos) {
            if (zwjVo != null) {
                if ("状态".equals(zwjVo.getBlmc())) {
                    zwjMap.put("Status", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("报警".equals(zwjVo.getBlmc())) {
                    zwjMap.put("Alarm", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("AlarmMsg".equals(zwjVo.getBlmc())) {
                    zwjMap.put("AlarmMsg", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("程序号".equals(zwjVo.getBlmc())) {
                    zwjMap.put("CurPgm", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                /*if ("最大压力".equals(zwjVo.getBlmc())) {
                    zwjMap.put("MaxPres", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }*/

                if ("工作台面尺寸".equals(zwjVo.getBlmc())) {
                    zwjMap.put("TableSize", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("轴行程正限位".equals(zwjVo.getBlmc())) {
                    zwjMap.put("LimitUpl", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("轴行程负限位".equals(zwjVo.getBlmc())) {
                    zwjMap.put("LimotDownl", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("实时下压行程".equals(zwjVo.getBlmc())) {
                    zwjMap.put("RtLimit", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("保压时间".equals(zwjVo.getBlmc())) {
                    zwjMap.put("DwellTime", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("角度检测值".equals(zwjVo.getBlmc())) {
                    zwjMap.put("AngleResultValue", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                if ("挠度补偿值".equals(zwjVo.getBlmc())) {
                    zwjMap.put("DeflectCom", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("下压速度".equals(zwjVo.getBlmc())) {
                    zwjMap.put("PreSpeed", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("下压压力".equals(zwjVo.getBlmc())) {
                    zwjMap.put("PrePress", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("折弯状态".equals(zwjVo.getBlmc())) {
                    zwjMap.put("WorkStatus", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }

                zwjMap.put(zwjVo.getBldz(), zwjVo.getCclm().toLowerCase(Locale.ROOT));

            }
        }
        return zwjMap;
    }

    public Map<String, String> zwj800(java.lang.String name) {
        List<BldzCclmVo> zwjVos = scadaMapper.find(name);
        Map<String, String> zwjMap = new HashMap<>();
        for (BldzCclmVo zwjVo : zwjVos) {
            if (zwjVo != null) {
                if ("状态".equals(zwjVo.getBlmc())) {
                    zwjMap.put("Status", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("程序号".equals(zwjVo.getBlmc())) {
                    zwjMap.put("CurPgm", zwjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
            }
        }
        return zwjMap;
    }

    public Map<String, String> jgqgj(String name) {
        List<BldzCclmVo> jgqgjVos = scadaMapper.find(name);
        Map<String, String> jgqgjMap = new HashMap<>();
        for (BldzCclmVo bldzCclmVo : jgqgjVos) {
            if (bldzCclmVo != null) {

                jgqgjMap.put(bldzCclmVo.getBldz(), bldzCclmVo.getCclm().toLowerCase(Locale.ROOT));
            }
        }
        return jgqgjMap;
    }

    public Map<String, String> blx(String name) {
        List<BldzCclmVo> blxVos = scadaMapper.find(name);
        Map<String, String> blxMap = new HashMap<>();
        for (BldzCclmVo blxVo : blxVos) {
            if (blxVo != null) {
                if ("设备状态".equals(blxVo.getBlmc())) {
                    blxMap.put("Status", blxVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("是否报警".equals(blxVo.getBlmc())) {
                    blxMap.put("Alarm", blxVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                blxMap.put(blxVo.getBldz(), blxVo.getCclm().toLowerCase(Locale.ROOT));
            }
        }
        return blxMap;
    }

    public Map<String, String> xgjx(String name) {
        List<BldzCclmVo> xgjxcVos = scadaMapper.find(name);
        Map<String, String> xgjxcMap = new HashMap<>();
        for (BldzCclmVo xgjxcVo : xgjxcVos) {
            if (xgjxcVo != null) {
                if ("行车运行状态".equals(xgjxcVo.getBlmc())) {
                    xgjxcMap.put("Status", xgjxcVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("设备故障".equals(xgjxcVo.getBlmc())) {
                    xgjxcMap.put("Alarm", xgjxcVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("钢板重量".equals(xgjxcVo.getBlmc())) {
                    xgjxcMap.put("LiftWeight", xgjxcVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("行车z轴当前位置".equals(xgjxcVo.getBlmc())) {
                    xgjxcMap.put("LiftHeight", xgjxcVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("勾吊速度".equals(xgjxcVo.getBlmc())) {
                    xgjxcMap.put("LiftSpeed", xgjxcVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                //  xgjxcMap.put(xgjxcVo.getBldz(), xgjxcVo.getCclm().toLowerCase(Locale.ROOT));
            }
        }
        return xgjxcMap;
    }

    public Map<String, List<String>> mse(String name) {
        List<BldzCclmVo> msr52Vos = scadaMapper.find(name);
        Map<String, List<String>> msr52Map = new HashMap<>();
        for (BldzCclmVo msr52Vo : msr52Vos) {
            if (msr52Vo != null) {
                if ("切割状态开启".equals(msr52Vo.getBlmc()) || "切割状态关闭".equals(msr52Vo.getBlmc())) {
                    List<String> list = msr52Map.computeIfAbsent("Status", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                } else if ("报警".contains(msr52Vo.getBlmc())) {
                    List<String> list = msr52Map.computeIfAbsent("Alarm", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                } else if ("工作模式".equals(msr52Vo.getBlmc())) {
                    List<String> list = msr52Map.computeIfAbsent("Mode", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                } else if ("绝对坐标X".equals(msr52Vo.getBlmc()) || "绝对坐标Y".equals(msr52Vo.getBlmc())) {
                    List<String> list = msr52Map.computeIfAbsent("AbsPos", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                } else if ("NC程序启动".equals(msr52Vo.getBlmc()) || "NC程序停止".equals(msr52Vo.getBlmc())) {
                    List<String> list = msr52Map.computeIfAbsent("NcStatus", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                } else if ("主程序号".equals(msr52Vo.getBlmc())) {
                        List<String> list = msr52Map.computeIfAbsent("MainPgm", k -> new ArrayList<String>());
                        list.add(msr52Vo.getCclm());
                        continue;
                } else if ("当前程序号".equals(msr52Vo.getBlmc())) {
                    List<String> list = msr52Map.computeIfAbsent("CurPgm", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                } else if ("加工时间".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CycSec", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }else
                if ("程序行号".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CurSeq", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }else
                if ("产量".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("PartCnt", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }else

                if ("当前程序块".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CurNcBlk", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }else
                if ("切割速度".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutSpeed", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }else
                if ("板材规格".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("PlateType", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                else
                if ("切割气体流量".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutGasFlow", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }else
                if ("保护气体流量".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ProGasFlow", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("切割状态开启".equals(msr52Vo.getBlmc()) || "切割状态关闭".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutStatus", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("切割厚度".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("CutThick", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("引弧时间".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ArcStrikeTime", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("弧压".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("ArcVoltage", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("工作电压".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("Voltage", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("隔缝补偿".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("GapOffset", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }
                if ("工作电流".equals(msr52Vo.getBlmc())) {
                    //转化为秒
                    List<String> list = msr52Map.computeIfAbsent("Current", k -> new ArrayList<String>());
                    list.add(msr52Vo.getCclm());
                    continue;
                }


            }
        }
        return msr52Map;
    }

    public Map<String, String> xpj(String name) {
        List<BldzCclmVo> xpjVos = scadaMapper.find(name);
        Map<String, String> xpjMap = new HashMap<>();
        for (BldzCclmVo xpjVo : xpjVos) {
            if (xpjVo != null) {
                if ("设备状态".equals(xpjVo.getBlmc())) {
                    xpjMap.put("Status", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("报警".equals(xpjVo.getBlmc())) {
                    xpjMap.put("Alarm", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("最大板厚".equals(xpjVo.getBlmc())) {
                    xpjMap.put("MaxThickness", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("最大板宽".equals(xpjVo.getBlmc())) {
                    xpjMap.put("MaxWidth", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("校平速度".equals(xpjVo.getBlmc())) {
                    xpjMap.put("MaxSpeed", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("上辊行程".equals(xpjVo.getBlmc())) {
                    xpjMap.put("RealLength", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                if ("上辊角度".equals(xpjVo.getBlmc())) {
                    xpjMap.put("RealAngle", xpjVo.getCclm().toLowerCase(Locale.ROOT));
                    continue;
                }
                xpjMap.put(xpjVo.getBldz(), xpjVo.getCclm().toLowerCase(Locale.ROOT));
            }
        }
        return xpjMap;
    }

    public Map<String, List<String>> lmx(String name) {
        List<BldzCclmVo> blxVos = scadaMapper.find(name);
        Map<String, List<String>> lmxMap = new HashMap<>();
        for (BldzCclmVo blxVo : blxVos) {
            if (blxVo != null) {
                if ("序列号".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("SerNum", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("软件版本".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("nckVer", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("伺服轴数".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Axes", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴数".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("SpinNum", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴最高转速".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("MaxSpeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }

                if ("状态运行".equals(blxVo.getBlmc()) || "状态故障报警".equals(blxVo.getBlmc()) || "状态机床等待".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Status", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("状态急停".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Emg", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("工作模式".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("Mode", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("轴名称1".equals(blxVo.getBlmc()) || "轴名称2".equals(blxVo.getBlmc()) || "轴名称3".equals(blxVo.getBlmc()) || "轴名称4".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AxisName", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("机械坐标X".equals(blxVo.getBlmc()) || "机械坐标Y".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("MachPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("绝对坐标X".equals(blxVo.getBlmc()) || "绝对坐标Y".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AbsPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("相对坐标X".equals(blxVo.getBlmc()) || "相对坐标Y".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("RelPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("剩余距离".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("RemPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }

                if ("程序运行状态".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("NcStatus", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主程序号".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("MainPgm", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("当前程序号".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CurPgm", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削时间".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CutTime", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("加工时间".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CycSec", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("程序行号".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CurSeq", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("产量".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("PartCnt", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("当前程序块".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("CurNcBlk", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("刀具号".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("TCode", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削倍率".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("OvFeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴倍率".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("OvSpin", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削速度".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("ActFeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("报警数量".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("alarmNums", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("报警类型".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AlarmType", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("报警号".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("AlarmNo", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴速度".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("ActSpin", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴负载1".equals(blxVo.getBlmc())) {
                    List<String> list = lmxMap.computeIfAbsent("SpinLoad1", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
            }
        }
        return lmxMap;
    }

    public Map<String, List<String>> pmz(String name) {
        List<BldzCclmVo> blxVos = scadaMapper.find(name);
        Map<String, List<String>> pmzMap = new HashMap<>();
        for (BldzCclmVo blxVo : blxVos) {
            if (blxVo != null) {
                if ("序列号".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("SerNum", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("软件版本".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("nckVer", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("伺服轴数".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("Axes", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴数".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("SpinNum", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴最高转速".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("MaxSpeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("状态作业".equals(blxVo.getBlmc()) || "状态待机".equals(blxVo.getBlmc()) || "状态故障".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("Status", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("急停".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("Emg", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("报警".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("Alarm", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("工作模式".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("Mode", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("轴名称".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("AxisName", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("机械坐标".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("MachPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("绝对坐标".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("AbsPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("相对坐标".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("RelPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("剩余距离".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("RemPos", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }

                if ("程序运行状态".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("NcStatus", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主程序号".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("MainPgm", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主程序注释".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("MainPgmMsg", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("当前程序号".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("CurPgm", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("当前程序注释".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("CurPgmMsg", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削时间".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("CutTime", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("加工时间".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("CycSec", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("程序行号".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("CurSeq", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("产量".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("PartCnt", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("当前程序块".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("CurNcBlk", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("刀具号".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("TCode", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削倍率".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("OvFeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴倍率".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("OvSpin", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削速度".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("ActFeed", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("切削指定速度".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("FCode", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴速度".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("ActSpin", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
                if ("主轴负载1".equals(blxVo.getBlmc())) {
                    List<String> list = pmzMap.computeIfAbsent("SpinLoad1", k -> new ArrayList<String>());
                    list.add(blxVo.getCclm());
                    continue;
                }
            }
        }
        return pmzMap;
    }

    /**
     * 获取证书sk解析后的码
     *
     * @return
     */
    public static String readSkFileToList(String skFile) {
        ///File file = new File(skFile);
        List<String> filelist = new ArrayList();
        filelist = returnFileCs(skFile);

        String info = "";
        // 遍历listStr集合
        for (String data : filelist) {
            // +换行
            info = info + data;
        }
        Base64.Decoder decoder = Base64.getDecoder();
        byte[] bytes = decoder.decode(info);
        return new String(bytes);
    }

    public static List<String> returnFileCs(String path) {
        List<String> listStr = new ArrayList<>();
        String url = System.getProperty("user.dir");
        // System.out.println(url);
        BufferedReader br;
        try {
            br = new BufferedReader(new InputStreamReader(new FileInputStream(url + path), "UTF-8"));
            String tempStr;
            while ((tempStr = br.readLine()) != null) {
                listStr.add(tempStr);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return listStr;
    }


}
